import java.awt.Color;
import java.awt.EventQueue;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.text.DefaultCaret;


public class Gui {

	private JFrame frame;
	private JTextField textField;
	private JTextField textField_1;
	private JTextField textField_2;
	private JTextField textField_3;
	private JButton btntart;
	private JTextArea txtrXY;
	private JScrollPane scrollPane;
	private JSeparator separator_2;
	private JLabel lblX;
	private JPanel panel;
	private JLabel lblYAxis;
	private JPanel panel_1;
	private JLabel lblZAxis;
	private JPanel panel_2;
	private JPanel panel_3;
	private Run run;
	private JButton btnStop;
	private JButton btnPause;
	private Thread runThread;
	private boolean paused = false;
	private JLabel lblValueX1;
	private JLabel lblValueX2;
	private JLabel lblValueX3;
	private JLabel lblValueX4;
	private JLabel lblValueX5;
	private JLabel lblValueY1;
	private JLabel lblValueY2;
	private JLabel lblValueY3;
	private JLabel lblValueY4;
	private JLabel lblValueY5;
	private JLabel lblValueZ1;
	private JLabel lblValueZ2;
	private JLabel lblValueZ3;
	private JLabel lblValueZ4;
	private JLabel lblValueZ5;
	private int paintPause = 25;
	private boolean stop = false;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Gui window = new Gui();
					window.frame.setVisible(true);
					window.frame.repaint();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Gui() {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException | InstantiationException
				| IllegalAccessException | UnsupportedLookAndFeelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		initialize();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
		run = new Run();
		run.setNormAndRange(0, 0, 0, 2);
		frame = new JFrame("Accelerometer monitor");
		frame.setBounds(100, 100, 1183, 600);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(null);

		JLabel lblXPokojnyStav = new JLabel("X pokojny stav:");
		lblXPokojnyStav.setBounds(10, 11, 75, 14);
		frame.getContentPane().add(lblXPokojnyStav);

		JLabel lblYPokojnyStav = new JLabel("Y pokojny stav:");
		lblYPokojnyStav.setBounds(10, 33, 75, 14);
		frame.getContentPane().add(lblYPokojnyStav);

		JLabel lblZPokojnyStav = new JLabel("Z pokojny stav:");
		lblZPokojnyStav.setBounds(10, 55, 75, 14);
		frame.getContentPane().add(lblZPokojnyStav);

		KeyListener txtFieldCheckKey = new KeyListener() {

			@Override
			public void keyTyped(KeyEvent arg0) {
				// TODO Auto-generated method stub
			}

			@Override
			public void keyReleased(KeyEvent arg0) {
				// TODO Auto-generated method stub
				if (checkInputs()) btntart.setEnabled(true);
				else btntart.setEnabled(false);
			}

			@Override
			public void keyPressed(KeyEvent arg0) {
				// TODO Auto-generated method stub

			}
		};
		
		FocusListener txtFieldFocusSelect = new FocusListener() {
			
			@Override
			public void focusLost(FocusEvent arg0) {
				// TODO Auto-generated method stub
				
			}
			
			@Override
			public void focusGained(FocusEvent arg0) {
				JTextField f = ((JTextField)arg0.getSource());
				f.select(0, f.getText().length());	
			}
		};
		textField = new JTextField();
		textField.setHorizontalAlignment(SwingConstants.RIGHT);
		textField.setBounds(95, 8, 47, 20);
		textField.addKeyListener(txtFieldCheckKey);
		textField.addFocusListener(txtFieldFocusSelect);
		frame.getContentPane().add(textField);
		textField.setColumns(10);

		textField_1 = new JTextField();
		textField_1.setHorizontalAlignment(SwingConstants.RIGHT);
		textField_1.setBounds(95, 30, 47, 20);
		textField_1.addKeyListener(txtFieldCheckKey);
		textField_1.addFocusListener(txtFieldFocusSelect);
		frame.getContentPane().add(textField_1);
		textField_1.setColumns(10);

		textField_2 = new JTextField();
		textField_2.setHorizontalAlignment(SwingConstants.RIGHT);
		textField_2.setBounds(95, 52, 47, 20);
		textField_2.addFocusListener(txtFieldFocusSelect);
		textField_2.addKeyListener(txtFieldCheckKey);
		frame.getContentPane().add(textField_2);
		textField_2.setColumns(10);

		JSeparator separator = new JSeparator();
		separator.setOrientation(SwingConstants.VERTICAL);
		separator.setBounds(152, 11, 2, 58);
		frame.getContentPane().add(separator);

		JLabel lblRozpatieHodnot = new JLabel("Rozpatie hodnot (+-):");
		lblRozpatieHodnot.setBounds(164, 11, 106, 14);
		frame.getContentPane().add(lblRozpatieHodnot);

		textField_3 = new JTextField();
		textField_3.setHorizontalAlignment(SwingConstants.RIGHT);
		textField_3.setBounds(280, 8, 47, 20);
		textField_3.addKeyListener(txtFieldCheckKey);
		textField_3.addFocusListener(txtFieldFocusSelect);
		frame.getContentPane().add(textField_3);
		textField_3.setColumns(10);

		btntart = new JButton("Start");
		btntart.setEnabled(false);
		btntart.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				txtrXY.setText("");
				run.connect();
				run.setNormAndRange(Integer.parseInt(textField.getText()), Integer.parseInt(textField_1.getText()), Integer.parseInt(textField_2.getText()), Integer.parseInt(textField_3.getText())*2);
				class Runs extends Thread {
					@Override
					public void run() {
						btntart.setEnabled(false);
						btnStop.setEnabled(true);
						btnPause.setEnabled(true);
						textField.setEditable(false);
						textField_1.setEditable(false);
						textField_2.setEditable(false);
						textField_3.setEditable(false);

						int graphLabelStep = run.range/6;
						lblValueX1.setText(Integer.toString(-2*graphLabelStep + run.x_norm));
						lblValueX2.setText(Integer.toString(-1*graphLabelStep + run.x_norm));
						lblValueX3.setText(Integer.toString(run.x_norm));
						lblValueX4.setText(Integer.toString(graphLabelStep + run.x_norm));
						lblValueX5.setText(Integer.toString(2*graphLabelStep + run.x_norm));
						lblValueY1.setText(Integer.toString(-2*graphLabelStep + run.y_norm));
						lblValueY2.setText(Integer.toString(-1*graphLabelStep + run.y_norm));
						lblValueY3.setText(Integer.toString(run.y_norm));
						lblValueY4.setText(Integer.toString(graphLabelStep + run.y_norm));
						lblValueY5.setText(Integer.toString(2*graphLabelStep + run.y_norm));
						lblValueZ1.setText(Integer.toString(-2*graphLabelStep + run.z_norm));
						lblValueZ2.setText(Integer.toString(-1*graphLabelStep + run.z_norm));
						lblValueZ3.setText(Integer.toString(run.z_norm));
						lblValueZ4.setText(Integer.toString(graphLabelStep + run.z_norm));
						lblValueZ5.setText(Integer.toString(2*graphLabelStep + run.z_norm));
						stop = false;

						while(!stop) {
							if (!run.readNewData())	break;
							frame.repaint();
							txtrXY.append("X:" + run.data_real.get(778).data[0] + "     Y:" + run.data_real.get(778).data[1] + "     Z:" + run.data_real.get(778).data[2] + "\n");

							try {
								synchronized (this) {		
									wait(paintPause);
								}

							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
							while(paused)
								try {
									synchronized (this) {
										wait();
									}

								} catch (InterruptedException e) {
									// TODO Auto-generated catch block
									e.printStackTrace();
								}
						}
						if (checkInputs()) btntart.setEnabled(true);
						else btntart.setEnabled(false);
						btnStop.setEnabled(false);
						btnPause.setEnabled(false);
						textField.setEditable(true);
						textField_1.setEditable(true);
						textField_2.setEditable(true);
						textField_3.setEditable(true);
						runThread = null;
						run.disconnect();
					}
				}
				runThread = (Runs)new Runs();
				runThread.start();
			}
		});
		btntart.setBounds(163, 51, 75, 23);
		frame.getContentPane().add(btntart);

		JSeparator separator_1 = new JSeparator();
		separator_1.setBounds(10, 80, 317, 2);
		frame.getContentPane().add(separator_1);

		scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 93, 317, 458);
		frame.getContentPane().add(scrollPane);

		txtrXY = new JTextArea();
		DefaultCaret caret = (DefaultCaret)txtrXY.getCaret();
		caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);
		txtrXY.setFont(new Font("Monospaced", Font.PLAIN, 18));
		txtrXY.setEditable(false);
		scrollPane.setViewportView(txtrXY);

		separator_2 = new JSeparator();
		separator_2.setOrientation(SwingConstants.VERTICAL);
		separator_2.setBounds(337, 11, 2, 540);
		frame.getContentPane().add(separator_2);

		lblX = new JLabel("X smer");
		lblX.setBounds(349, 11, 46, 14);
		frame.getContentPane().add(lblX);

		panel = run.getGraphXYZPanel();
		panel.setBackground(Color.WHITE);
		panel.setBounds(377, 24, 780, 161);


		lblYAxis = new JLabel("Y smer");
		lblYAxis.setBounds(349, 195, 46, 14);
		frame.getContentPane().add(lblYAxis);

		panel_1 = run.getGraphXYZPanel();
		panel_1.setBackground(Color.WHITE);
		panel_1.setBounds(377, 207, 780, 161);


		lblZAxis = new JLabel("Z smer");
		lblZAxis.setBounds(349, 378, 46, 14);
		frame.getContentPane().add(lblZAxis);

		panel_2 = run.getGraphXYZPanel();
		panel_2.setBackground(Color.WHITE);
		panel_2.setBounds(377, 391, 780, 161);
		frame.getContentPane().add(panel_2);
		frame.getContentPane().add(panel_1);
		frame.getContentPane().add(panel);

		btnStop = new JButton("Stop");
		btnStop.setEnabled(false);
		btnStop.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent arg0) {
				stop = true;	
				paused = false;
				synchronized (runThread) {
					runThread.notify();
				}				
				btnPause.setText("Pause");
			}
		});
		btnStop.setBounds(248, 51, 79, 23);
		frame.getContentPane().add(btnStop);

		btnPause = new JButton("Pause");
		btnPause.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {

				if (btnPause.getText().equals("Pause")) {
					paused = true;
					btnPause.setText("Resume");
				}
				else {
					paused = false;
					synchronized (runThread) {
						runThread.notify();
					}

					btnPause.setText("Pause");
				}
			}
		});
		btnPause.setEnabled(false);
		btnPause.setBounds(163, 29, 75, 23);
		frame.getContentPane().add(btnPause);

		lblValueX1 = new JLabel("");
		lblValueX1.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueX1.setBounds(343, 44, 30, 14);
		frame.getContentPane().add(lblValueX1);

		lblValueX2 = new JLabel("");
		lblValueX2.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueX2.setBounds(343, 71, 30, 14);
		frame.getContentPane().add(lblValueX2);

		lblValueX3 = new JLabel("");
		lblValueX3.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueX3.setBounds(343, 97, 30, 14);
		frame.getContentPane().add(lblValueX3);

		lblValueX4 = new JLabel("");
		lblValueX4.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueX4.setBounds(343, 123, 30, 14);
		frame.getContentPane().add(lblValueX4);

		lblValueX5 = new JLabel("");
		lblValueX5.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueX5.setBounds(343, 150, 30, 14);
		frame.getContentPane().add(lblValueX5);

		lblValueY1 = new JLabel("");
		lblValueY1.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueY1.setBounds(343, 227, 30, 14);
		frame.getContentPane().add(lblValueY1);

		lblValueY2 = new JLabel("");
		lblValueY2.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueY2.setBounds(343, 254, 30, 14);
		frame.getContentPane().add(lblValueY2);

		lblValueY3 = new JLabel("");
		lblValueY3.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueY3.setBounds(343, 280, 30, 14);
		frame.getContentPane().add(lblValueY3);

		lblValueY4 = new JLabel("");
		lblValueY4.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueY4.setBounds(343, 307, 30, 14);
		frame.getContentPane().add(lblValueY4);

		lblValueY5 = new JLabel("");
		lblValueY5.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueY5.setBounds(343, 335, 30, 14);
		frame.getContentPane().add(lblValueY5);

		lblValueZ1 = new JLabel("");
		lblValueZ1.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueZ1.setBounds(343, 411, 30, 14);
		frame.getContentPane().add(lblValueZ1);

		lblValueZ2 = new JLabel("");
		lblValueZ2.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueZ2.setBounds(343, 438, 30, 14);
		frame.getContentPane().add(lblValueZ2);

		lblValueZ3 = new JLabel("");
		lblValueZ3.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueZ3.setBounds(343, 464, 30, 14);
		frame.getContentPane().add(lblValueZ3);

		lblValueZ4 = new JLabel("");
		lblValueZ4.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueZ4.setBounds(343, 491, 30, 14);
		frame.getContentPane().add(lblValueZ4);

		lblValueZ5 = new JLabel("");
		lblValueZ5.setHorizontalAlignment(SwingConstants.RIGHT);
		lblValueZ5.setBounds(343, 519, 30, 14);
		frame.getContentPane().add(lblValueZ5);
		
		JButton btnXyzxy = new JButton("XYZ/XY");
		btnXyzxy.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (panel.isVisible()) {
					panel.setVisible(false);
					panel_1.setVisible(false);
					panel_2.setVisible(false);
					
					lblX.setVisible(false);
					lblYAxis.setVisible(false);
					lblZAxis.setVisible(false);
					
					lblValueX1.setVisible(false);
					lblValueX2.setVisible(false);
					lblValueX3.setVisible(false);
					lblValueX4.setVisible(false);
					lblValueX5.setVisible(false);
					lblValueY1.setVisible(false);
					lblValueY2.setVisible(false);
					lblValueY3.setVisible(false);
					lblValueY4.setVisible(false);
					lblValueY5.setVisible(false);
					lblValueZ1.setVisible(false);
					lblValueZ2.setVisible(false);
					lblValueZ3.setVisible(false);
					lblValueZ4.setVisible(false);
					lblValueZ5.setVisible(false);
					
					panel_3.setVisible(true);
				}
				else {
					panel.setVisible(true);
					panel_1.setVisible(true);
					panel_2.setVisible(true);
					
					lblX.setVisible(true);
					lblYAxis.setVisible(true);
					lblZAxis.setVisible(true);
					
					lblValueX1.setVisible(true);
					lblValueX2.setVisible(true);
					lblValueX3.setVisible(true);
					lblValueX4.setVisible(true);
					lblValueX5.setVisible(true);
					lblValueY1.setVisible(true);
					lblValueY2.setVisible(true);
					lblValueY3.setVisible(true);
					lblValueY4.setVisible(true);
					lblValueY5.setVisible(true);
					lblValueZ1.setVisible(true);
					lblValueZ2.setVisible(true);
					lblValueZ3.setVisible(true);
					lblValueZ4.setVisible(true);
					lblValueZ5.setVisible(true);
					
					panel_3.setVisible(false);
				}
				frame.repaint();
		}
		});
		btnXyzxy.setBounds(248, 29, 79, 23);
		frame.getContentPane().add(btnXyzxy);
		
		//panel_3 = new JPanel();
		panel_3 = run.getGraphXYPanel();
		panel_3.setBounds(349, 11, 808, 540);
		panel_3.setVisible(false);
		frame.getContentPane().add(panel_3);
	}

	public boolean checkInputs() {

		if (textField.getText().isEmpty() || textField_1.getText().isEmpty() || textField_2.getText().isEmpty() || textField_3.getText().isEmpty()) return false;

		try {
			Integer.parseInt(textField.getText());
			Integer.parseInt(textField_1.getText());
			Integer.parseInt(textField_2.getText());
			Integer.parseInt(textField_3.getText());
		} catch (NumberFormatException e) {
			return false;
		}
		return true;

	}
}
