import gnu.io.SerialPort;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Random;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.swing.JPanel;

class Data {
	int[] data = new int[3];

	public Data(int x, int y, int z) {
		data[0] = x;
		data[1] = y;
		data[2] = z;
	}
}

public class Run {

	ArrayList<Data> data = new ArrayList<Data>();
	ArrayList<Data> data_real = new ArrayList<Data>();
	ArrayList<Data> data_diff = new ArrayList<Data>();
	ArrayList<Data> data_new = new ArrayList<Data>();
	String carry = "";

	int one_step = 1;
	int data_rot = 0;

	int x_avg = 0;
	int y_avg = 0;
	int z_avg = 0;
	int count = 0;

	int x_norm, y_norm, z_norm;
	int range;

	Random rangen;
	
	//////////////////////////
	String portName = "COM8";
	int baudRate = 9100;
	//////////////////////////

	InputStream in;	
	SerialPort serialPort = null;
	boolean firstReading ;

	public boolean connect() {
		/*
		 * Pre citanie z portu
		 */
//		CommPortIdentifier portId = null;
//		try {
//			portId = CommPortIdentifier.getPortIdentifier(portName);
//		} catch (NoSuchPortException e1) {
//			// TODO Auto-generated catch block
//			System.out.println("No such port.");
//			return false;
//		}
//		try {
//			serialPort = (SerialPort) portId.open("Accelerometer monitor", 5000);
//		} catch (PortInUseException e) {
//			// TODO Auto-generated catch block
//			System.out.println("Port in use.");
//			return false;
//		}
//
//		try {
//			serialPort.setSerialPortParams(baudRate, SerialPort.DATABITS_8,	SerialPort.STOPBITS_1, SerialPort.PARITY_NONE);
//		} catch (UnsupportedCommOperationException e) {
//			// TODO Auto-generated catch block
//			System.out.println(e.getMessage());
//			return false;
//		}
//
//		try {
//			in = serialPort.getInputStream();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//			serialPort.close();
//			return false;
//		}
//		return true;

		/*
		 * Pre citanie zo suboru
		 */
				try {
					in = new FileInputStream("vstup_real.txt");
				} catch (FileNotFoundException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return true;
	}

	public void disconnect() {
		if (serialPort != null) serialPort.close();
		try {
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
	}

	public void setNormAndRange(int x_norm, int y_norm, int z_norm, int range) {
		int x = x_norm - (x_norm - range/2);
		int y = y_norm - (y_norm - range/2);
		int z = z_norm - (z_norm - range/2);

		x /= range/160.0;
		y /= range/160.0;
		z /= range/160.0;

		data.clear();
		data_real.clear();
		data_new.clear();
		carry = "";
		for (int i = 0; i <= 778; i++) {
			data.add(new Data(x, y, z));
			data_real.add(new Data(0, 0, 0));
		}
		data_diff.clear();
		data_diff.add(new Data(0, 0, 0));

		this.x_norm = x_norm;
		this.y_norm = y_norm;
		this.z_norm = z_norm;
		this.range = range;
		rangen = new Random();
		firstReading = true;
	}

	public String syncStream(String buff) {
		firstReading = false;
		Pattern pattern = Pattern.compile("&-?\\d+\\s-?\\d+\\s-?\\d+&");
		Matcher matcher = pattern.matcher(buff);
		if (matcher.find())
			return buff.substring(matcher.start(), buff.length());
		else return buff;
	}

	public boolean readNewData() {				
		if (data_new.isEmpty()) {
			if (in == null)	return false;
			byte[] buffer = new byte[1024];
			int read_len = -1;
			try {
				read_len = in.read(buffer);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			if (read_len == -1) {
				try {
					in.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				return false;
			}
			//System.out.println(new String(buffer, 0, read_len));
			String read_str = new String(buffer, 0, read_len);
			read_str = carry + read_str;
			if (firstReading) read_str = syncStream(read_str);
			while (read_str.matches("&-?\\d+\\s-?\\d+\\s-?\\d+&.*")) {
				int stop = read_str.indexOf("&", 1);
				String[] split = read_str.substring(1, stop).split("\\s");
				read_str = read_str.substring(stop + 1, read_str.length());
				data_new.add(new Data(Integer.parseInt(split[0]), Integer.parseInt(split[1]), Integer.parseInt(split[2])));
			}			
			carry = read_str;
		}

		if (data_new.isEmpty())
			return false;

		Data new_data = data_new.remove(0);
		int x = new_data.data[0];
		int y = new_data.data[1];
		int z = new_data.data[2];

		data_real.remove(0);
		data_real.add(new Data(x, y, z));
		
		int x_diff, y_diff;
		if (data_real.get(777).data[0] == 0 && data_real.get(777).data[1] == 0 && data_real.get(777).data[2] == 0) {
			x_diff = x - x_norm;
			y_diff = y - y_norm;
		} else {
			x_diff = x - data_real.get(777).data[0];
			y_diff = y - data_real.get(777).data[1];
		}
		synchronized (data_diff) {
			data_diff.add(new Data(x_diff, y_diff, 0));
		}

		z = (z + z_norm)/2;

		x -= (x_norm - range/2);
		y -= (y_norm - range/2);
		z -= (z_norm - range/2);

		x /= range/160.0;
		y /= range/160.0;
		z /= range/160.0;

		if (x < 1) x = 1;
		if (x > 159) x = 159;
		if (y < 1) y = 1;
		if (y > 159) y = 159;
		if (z < 1) z = 1;
		if (z > 159) z = 159;

		//		if (count == 10) {
		//			data.remove(0);
		//			data.add(new Data(x_avg/count, y_avg/count, z_avg/count));
		//			x_avg = 0;
		//			y_avg = 0;
		//			z_avg = 0;
		//			count = 0;
		//		}
		//		else {
		//			x_avg += x;
		//			y_avg += y;
		//			z_avg += z;
		//			count++;
		//		}

		data.remove(0);
		data.add(new Data(x, y, z));
		return true;
	}

	@SuppressWarnings("serial")
	class GraphXY extends JPanel {
		@Override
		protected void paintComponent(Graphics arg0) {
			int x_coord = 404;
			int y_coord = 270;

			Graphics2D g2d = (Graphics2D) arg0;
			g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			g2d.setColor(Color.white);
			g2d.fillRect(0, 0, 807, 539);
			g2d.setColor(Color.black);
			g2d.drawRect(0, 0, 807, 539);

			synchronized (data_diff) {
				for (Data d: data_diff) {
					g2d.setColor(Color.black);
					g2d.drawLine(x_coord, y_coord, x_coord + d.data[0], y_coord + d.data[1]);
					x_coord += d.data[0];
					y_coord += d.data[1];
					g2d.setColor(Color.red);
					g2d.drawRect(x_coord - 2, y_coord - 2, 4, 4);				
				}
			}
		}
	}

	@SuppressWarnings("serial")
	class GraphXYZ extends JPanel {
		@Override
		protected void paintComponent(Graphics arg0) {
			Graphics2D g2d = (Graphics2D) arg0;
			g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			g2d.setColor(Color.white);
			g2d.fillRect(0, 0, 779, 160);
			g2d.setColor(Color.black);
			g2d.drawRect(0, 0, 779, 160);
			g2d.drawLine(0, 80, 779, 80);
			g2d.setColor(Color.LIGHT_GRAY);
			g2d.drawLine(1, 79, 778, 79);
			g2d.drawLine(1, 81, 778, 81);
			g2d.drawLine(1, 26, 778, 26);
			g2d.drawLine(1, 53, 778, 53);				
			g2d.drawLine(1, 106, 778, 106);
			g2d.drawLine(1, 133, 778, 133);
			int x = 1;
			switch (data_rot) {
			case 0: 
				g2d.setColor(Color.red);
				break;
			case 1: 
				g2d.setColor(Color.blue);
				break;
			case 2: 
				g2d.setColor(Color.magenta);
				break;
			}
			for (int i = 1; i < 778; i++)
				g2d.drawLine(x, data.get(i-1).data[data_rot], x += one_step, data.get(i).data[data_rot]);
			data_rot = (data_rot + 1) % 3;
		}
	}

	public GraphXYZ getGraphXYZPanel() {
		return new GraphXYZ();
	}

	public GraphXY getGraphXYPanel() {
		return new GraphXY();
	}

	public static void main(String[] args) throws IOException {	

		//				PrintWriter out = new PrintWriter("vstup.txt");
		//				Random rg = new Random();
		//				for (int i = 0; i < 10000; i++)
		//					out.print("&" + (rg.nextInt(100)-200) + "\t" + (rg.nextInt(100)+150) + "\t" + (rg.nextInt(100)+350) + "&");
		//				out.close();
	}
}
